//
// Site Manager Items
function GetItemType(item) {
	/* var newItem = {
		name: name,
		url: url,
		size: size,
		lastModified: lastModified,
		isContainer: isContainer,
		isContainerOpen: isContainerOpen,
		isContainerEmpty: isContainerEmpty,
		isSymLink: isSymLink,
		level: level,
		hidden: hidden,
		realIndex: realRowIndex
	}; */  
	var type;
	if (item.level == 0) 
		type = "Site";
	else if (item.isContainer) 
		type = "Folder";
	else if (!IsHiddenByFilter("html", item.url))
		type = "HTML Document";
	else if (!IsHiddenByFilter("cgi", item.url))
		type = "Server script";
	else if (!IsHiddenByFilter("css", item.url))
		type = "CSS Stylesheet";
	else if (!IsHiddenByFilter("images", item.url))
		type = "Image";
	else
		type = "File";
	return type;
}
function GetNsmSite(url) {
	var rowIndex = GetNsmItem(url).realIndex;

	// Get related site item
	while (gFilteredItemsArray[rowIndex].level > 0)
		rowIndex--;
	var siteItem = gFilteredItemsArray[rowIndex];
	siteItem.browseUrl = NvuPublishPrefs.getCharPref(siteItem.name + ".browse_url");
	return siteItem;
}
function GetNsmItem(url) {
	// Get related item index
	var rowIndex = 0;
	if (url) {
		while ((gFilteredItemsArray[rowIndex].url != url) && (rowIndex < gFilteredItemsArray.length-1))
			rowIndex++;
	} else
		rowIndex = GetSelectedItem(gDialog.SiteTree);
	return gFilteredItemsArray[rowIndex];
}
//
// Modified 'openFile' function (override that in 'comm.jar/editor/content/sitemanager.js')
function openFile(e) {
	if (e.button != 0)
		return;
	
	var item = GetNsmItem();
	var editor = "";

	// Folder (do nothing)
	if (item.isContainer) {
	}
	// HTML file: open in a new / existing tab
	else if (!IsHiddenByFilter("html", item.url)) {
		var prefs = window.top.GetPrefs();
		var newTab = false; // default is false
		try {
			newTab = prefs.getBoolPref("editor.nvu.sitemanager.openInNewTab");
			DEBUG ( "prefs found" );
		} catch (e) {};
		//~ EnableAllUI(false);
		//~ window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
		//~ window.top.editPage(item.url, window.top, true, newTab);
		NsmEdit(newTab, item.url)
	} 
	// other file: open with external editor
	else {
		// Get file type
		// TODO: loop with all user-defined filters
		if (!IsHiddenByFilter("images", item.url))
			editor = "imgEditor";
		else if (!IsHiddenByFilter("css", item.url))
			editor = "cssEditor";
		else
			editor = "extEditor";
		
		// Get appropriate editor path
		try {
			// ":" is used as PortableNvu's root dir (demo, should use '%NvuRoot%' and '%NvuProfile%' instead)
			var AppPath = NsmPrefs.getCharPref(editor);
			//~ DEBUG ( "prefs found" );
		} catch (e) {
			EnableAllUI(false);
			window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
			window.top.document.open(item.url, window.top, true, true);
		};
		
		// Launch appropriate editor
		try {
			NsmLaunchExe(AppPath, item.url);
			//~ DEBUG ( "app launched" );
		} catch (e) {};
	}
}
//
// Modified 'GetCurrentEditorElement' function (override that in 'comm.jar/editor/content/editorUtilities.js')
var currentEditor = {};
var documentUrl = "";
function GetCurrentEditorElement() {
  //~ var tmpWindow = window;
  // Kaze: modified to point at the top window (so GetCurrentEditor and other functions work in the site manager)
  var tmpWindow = window.top;
  
  do {
    // Get the <editor> element(s)
    var tabeditor = tmpWindow.document.getElementById("tabeditor");

    // This will change if we support > 1 editor element
    if (tabeditor )
      return tabeditor.getCurrentEditorElement() ;

    tmpWindow = tmpWindow.opener;
  } 
  while (tmpWindow);

  return null;
}
//
// NsmEdit : very much like 'editPage', but allows to choose wether to open in a new tab or in a new window,
// and uses 'window.top' instead of 'window'
function NsmEdit(newTab, FileURL) {
	//~ var prefs = window.top.GetPrefs();
	//~ var newTab = false; // default is false
	//~ try {
		//~ newTab = prefs.getBoolPref("editor.nvu.sitemanager.openInNewTab");
		//~ DEBUG ( "prefs found" );
	//~ } catch (e) {};	
	FileURL = (FileURL) ? FileURL : GetNsmItem().url;
	
	EnableAllUI(false);
	window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
	window.top.editPage(FileURL, window.top, true, newTab);
	
	// added: if omitted, the sitemanager freezes when opening a new window.
	if (!newTab)
		EnableAllUI(true); 
}
//
// main: show context menu in the Site Manager
function NsmConText(menuid) {
	//~ NsmBundle = document.getElementById("bundle_nsmcontext");
	var NsmStringBundle = srGetStrBundle("chrome://nsmcontext/locale/nsmcontext.properties");
	
	var item = GetNsmItem();
	var scheme = GetScheme(item.url);
	NsmClearMenu(menuid, LaunchyContext.apps);
	
	// Folders
	if (item.isContainer) {
		NsmAppendLaunchyItems(menuid, 6);
		if (scheme == "ftp")
			NsmAppendLaunchyItems(menuid, 4);
		NsmAppendMenuSeparator(menuid);
	}
	// HTML documents
	else if (!IsHiddenByFilter("html", item.url)) {
		try {
			NsmAppendMenuItem(menuid, NsmStringBundle.GetStringFromName("NsmConText-NewTab"), "NsmEdit(true,'')");
			NsmAppendMenuItem(menuid, NsmStringBundle.GetStringFromName("NsmConText-NewWindow"), "NsmEdit(false,'')");
			NsmAppendMenuSeparator(menuid);
		} catch (e) {};
		//~ NsmAppendMenuItem(menuid, getNsmBundle2("NewTab"), editNewTab);
		//~ NsmAppendMenuItem(menuid, getNsmBundle2("NewWindow"), editNewPage);
		//~ NsmAppendMenuItem(menuid, getNsmBundle("NewTab"), "nsEditLinkCommand.doCommand()");
		//~ NsmAppendMenuItem(menuid, getNsmBundle("NewWindow"), "nsEditLinkCommand.doCommand()");
		//~ try {
			//~ var NsmStringBundle = document.getElementById("NsmBundle");
			//~ NsmAppendMenuItem(menuid, NsmStringBundle.getString("NsmConText-NewTab"), "NsmEdit(true,'')");
			//~ NsmAppendMenuItem(menuid, NsmStringBundle.getString("NsmConText-NewWindow"), "NsmEdit(false,'')");
			//~ NsmAppendMenuSeparator(menuid);
		//~ } catch (e) {};
		//~ NsmAppendMenuItem(menuid, getNsmBundle("NewTab"), "NsmEdit(true,'')");
		//~ NsmAppendMenuItem(menuid, getNsmBundle("NewWindow"), "NsmEdit(false,'')");
		//~ NsmAppendMenuSeparator(menuid);
		try {
			if ((scheme == "file") && NsmPrefs.getBoolPref("ShowEditors")) {
				NsmAppendLaunchyItems(menuid, 7);
				NsmAppendMenuSeparator(menuid);
			}
			if (NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(menuid, 1);
				NsmAppendMenuSeparator(menuid);
			}
		} catch (e) {};
	}
	// Server-side scripts
	else if (!IsHiddenByFilter("cgi", item.url)) {
		try {
			if (scheme == "file") {
				NsmAppendLaunchyItems(menuid, 7);
				NsmAppendMenuSeparator(menuid);
			}
			if ((GetNsmSite().browseUrl != "http://") && NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(menuid, 1);
				NsmAppendMenuSeparator(menuid);
			}
		} catch (e) {};
		//~ nsmMenu.AppendMenuPopup(menuid, "Ouvrir", "NsmConTextOpen(this)");
		//~ nsmMenu.AppendMenuPopup(menuid, "Navigateur", "NsmConTextPreview(this)");
	}
	// other local files
	else if (scheme == "file") {
		if (!IsHiddenByFilter("images", item.url))
			NsmAppendLaunchyItems(menuid, 8);
		else
			NsmAppendLaunchyItems(menuid, 7);
		NsmAppendMenuSeparator(menuid);
	}
	// site item or file/folder item ?
	if (item.level > 0) {
		// file or folder : rename, remove or show properties
		try {
			NsmAppendMenuItem(menuid, NsmStringBundle.GetStringFromName("NsmConText-Rename"), "Rename()");
			NsmAppendMenuItem(menuid, NsmStringBundle.GetStringFromName("NsmConText-Remove"), "RemoveFileOrDir()");
			NsmAppendMenuSeparator(menuid);
		} catch (e) {};
		//~ NsmAppendMenuItem(menuid, getNsmBundle("Rename"), "Rename()");
		//~ NsmAppendMenuItem(menuid, getNsmBundle("Remove"), "RemoveFileOrDir()");
		//~ NsmAppendMenuSeparator(menuid);
		// debug
		//~ NsmAppendMenuItem(menuid, "CaScadeS", "openCascadesDialog()");
		//~ NsmAppendMenuItem(menuid, getNsmBundle("Properties"), "openPropDialog()");
	} else {
		// site : http preview
		try {
			//~ if ((NsmPrefs.getBoolPref("ShowBrowsers")) && (NvuPublishPrefs.getCharPref(item.name + ".browse_url") != "http://")) {
			if (NvuPublishPrefs.getCharPref(item.name+".browse_url") != "http://") {
				NsmAppendLaunchyItems(menuid, 1);
				NsmAppendMenuSeparator(menuid);
			}
		} catch (e) {};
	}
	//~ NsmAppendMenuItem(menuid, "NsmConText...", "openPrefDialog()");
	NsmAppendSignature(menuid);
/*	
	//~ var menuitem = document.getElementById("NsmDefaultAction");
	//~ menuitem.setAttribute("class", "menuitem-iconic");
	//~ menuitem.setAttribute("image", iconPath);
	//~ alert(iconPath);
	//~ menuitem.setAttribute("image", "moz-icon:file://" + LaunchyContext.apps[i].exe + "?size=16");
	//~ menuitem.setAttribute("icon", icon);
}*/
}
/* oldies
function NsmConText(menuid) {
	//~ NsmBundle = document.getElementById("bundle_nsmcontext");
	
	var edit = document.getElementById("NsmConText-edit");
	NsmClearMenu(edit);
	var browse = document.getElementById("NsmConText-browse");
	NsmClearMenu(browse);
	//~ NsmClearMenu(menuid, LaunchyContext.apps);
	var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	var scheme = GetScheme(item.url);
	if (item.isContainer) {
		NsmAppendLaunchyItems(browse, 6);
		if (scheme == "ftp")
			NsmAppendLaunchyItems(browse, 4);
		NsmAppendMenuSeparator(browse);
	} else if (!IsHiddenByFilter("html", item.url)) {
		//~ nsmMenu.AppendMenuItem("Ouvrir", "openFile(event)");
		NsmAppendMenuItem(edit, "Nouvel onglet", "NsmEdit(true,'')");
		NsmAppendMenuItem(edit, "Nouvelle fentre", "NsmEdit(false,'')");
		NsmAppendMenuSeparator(edit);
		try {
			if ((scheme == "file") && NsmPrefs.getBoolPref("ShowEditors")) {
				NsmAppendLaunchyItems(edit, 7);
				NsmAppendMenuSeparator(edit);
			}
			if (NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(browse, 1);
				NsmAppendMenuSeparator(browse);
			}
		} catch (e) {};
		//~ nsmMenu.AppendMenuPopup(menuid, "Ouvrir", "NsmConTextOpen(this)");
		//~ nsmMenu.AppendMenuPopup(menuid, "Navigateur", "NsmConTextPreview(this)");
	} else if (!IsHiddenByFilter("cgi", item.url)) {
		try {
			if (scheme == "file") {
				NsmAppendLaunchyItems(edit, 7);
				NsmAppendMenuSeparator(edit);
			}
			if ((GetNsmSite().browseUrl != "http://") && NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(browse, 1);
				NsmAppendMenuSeparator(browse);
			}
		} catch (e) {};
		//~ nsmMenu.AppendMenuPopup(menuid, "Ouvrir", "NsmConTextOpen(this)");
		//~ nsmMenu.AppendMenuPopup(menuid, "Navigateur", "NsmConTextPreview(this)");
	} else if (scheme == "file") {
		if (!IsHiddenByFilter("images", item.url))
			NsmAppendLaunchyItems(edit, 8);
		else
			NsmAppendLaunchyItems(edit, 7);
		NsmAppendMenuSeparator(edit);
	}
	
	if (item.level > 0) {
		//~ NsmAppendMenuItem(menuid, "Renommer", "Rename()");
		//~ NsmAppendMenuItem(menuid, "Supprimer", "RemoveFileOrDir()");
		//~ NsmAppendMenuItem(menuid, NsmBundle.Rename, "Rename()");
		//~ NsmAppendMenuItem(menuid, NsmBundle.Remove, "RemoveFileOrDir()");
		//~ NsmAppendMenuSeparator(menuid);
		//~ NsmAppendMenuItem(menuid, NsmBundle.Properties, "openPropDialog()");
	} else {
		try {
			//~ if ((NsmPrefs.getBoolPref("ShowBrowsers")) && (NvuPublishPrefs.getCharPref(item.name + ".browse_url") != "http://")) {
			if (NvuPublishPrefs.getCharPref(item.name+".browse_url") != "http://") {
				NsmAppendLaunchyItems(browse, 1);
				NsmAppendMenuSeparator(browse);
			}
		} catch (e) {};
	}
	//~ NsmAppendMenuItem(menuid, "NsmConText...", "openPrefDialog()");
}
function NsmConTextPreview(menuid) {
	//~ NsmClearMenu(menuid);
	NsmAppendMenuItem(menuid, "Navigateur par dfaut", "NsmPreviewAppRef=-1; loadExternalURL()");
	NsmAppendMenuSeparator(menuid);
	NsmAppendLaunchyItems(menuid, 1);
}
function NsmConTextOpen(menuid) {
	//~ NsmClearMenu(menuid);
	NsmAppendMenuItem(menuid, "Nouvel onglet", "NsmEdit(true,'')");
	NsmAppendMenuItem(menuid, "Nouvelle fentre", "NsmEdit(false,'')");
	NsmAppendMenuSeparator(menuid);
	NsmAppendLaunchyItems(menuid, 7);
}
function NsmLaunchyContext(menuid) {
	NsmClearMenu(menuid);

	var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	if (item.isContainer) {
		NsmAppendLaunchyItems(menuid, 6);
	} else {
		if (!IsHiddenByFilter("html", item.url)) {
			NsmAppendLaunchyItems(menuid, 1);
		}
		if (!IsHiddenByFilter("images", item.url)) {
			NsmAppendLaunchyItems(menuid, 8);
		} else {
			NsmAppendLaunchyItems(menuid, 7);
		}
	}

	var menuitem = document.createElement("menuitem");
	menuitem.setAttribute("label", "preferences...");
	menuitem.setAttribute("oncommand", "openDialog('chrome://launchy/content/options.xul', '', 'chrome,modal');");
	menuid.appendChild(menuitem);
}
*/
